{\rtf1\ansi\ansicpg1252\cocoartf1561\cocoasubrtf610
{\fonttbl\f0\fswiss\fcharset0 Helvetica;}
{\colortbl;\red255\green255\blue255;\red83\green85\blue2;\red52\green52\blue52;\red115\green0\blue2;
\red0\green0\blue117;\red82\green0\blue83;\red11\green84\blue83;\red16\green121\blue2;}
{\*\expandedcolortbl;;\cssrgb\c40000\c40000\c0;\cssrgb\c26667\c26667\c26667;\cssrgb\c53333\c0\c0;
\cssrgb\c0\c0\c53333;\cssrgb\c40000\c0\c40000;\cssrgb\c0\c40000\c40000;\cssrgb\c0\c53333\c0;}
\paperw11900\paperh16840\margl1440\margr1440\vieww10800\viewh8400\viewkind0
\deftab720
\pard\pardeftab720\partightenfactor0

\f0\fs26\fsmilli13333 \cf2 \expnd0\expndtw0\kerning0
\{\cf0 \
\
\cf3 \'a0 \'a0 \cf4 /**\
\'a0 \'a0 \'a0* Create a textual representation for a Key object.\
\'a0 \'a0 \'a0*\
\'a0 \'a0 \'a0* @param key key\
\'a0 \'a0 \'a0* @return textual representation\
\'a0 \'a0 \'a0*/\cf0 \
\cf3 \'a0 \'a0 \cf5 def\cf3  \cf6 String\cf3  toKeyString\cf2 (\cf6 Key\cf3  key\cf2 )\cf3  \cf2 \{\cf0 \
\cf3 \'a0 \'a0 \'a0 \'a0 \cf4 // key.ordinal() is a number starting with C Major = 0 and A Minor = 0,\cf0 \
\cf3 \'a0 \'a0 \'a0 \'a0 \cf4 // then following the order in the Circle of Fifths.\cf0 \
\cf3 \'a0 \'a0 \'a0 \'a0 \cf4 // Let's shift by 8 and make sure 0 is converted to 12.\cf0 \
\cf3 \'a0 \'a0 \'a0 \'a0 \cf5 int\cf3  i \cf2 =\cf3  \cf2 (\cf3 key\cf2 .\cf3 ordinal\cf2 ()\cf3  \cf2 +\cf3  \cf7 8\cf2 )\cf3  \cf2 %\cf3  \cf7 12\cf0 \
\cf3 \'a0 \'a0 \'a0 \'a0 i \cf2 =\cf3  i \cf2 ==\cf3  \cf7 0\cf3  \cf2 ?\cf3  \cf7 12\cf3  \cf2 :\cf3  i\cf0 \
\cf3 \'a0 \'a0 \'a0 \'a0 \cf6 String\cf3  ab \cf2 =\cf3  key\cf2 .\cf3 isMajor\cf2 ()\cf3  \cf2 ?\cf3  \cf8 "A"\cf3  \cf2 :\cf3  \cf8 "B"\cf0 \
\cf3 \'a0 \'a0 \'a0 \'a0 \cf4 // create the final string\cf0 \
\cf3 \'a0 \'a0 \'a0 \'a0 \cf5 return\cf3  \cf8 "$i$ab"\cf0 \
\cf3 \'a0 \'a0 \cf2 \}\cf0 \
\
\cf3 \'a0 \'a0 \cf4 /**\
\'a0 \'a0 \'a0* Create a tooltip representation for a key object.\
\'a0 \'a0 \'a0* This may also include html-tags.\
\'a0 \'a0 \'a0*\
\'a0 \'a0 \'a0* @param key key\
\'a0 \'a0 \'a0* @return tooltip representation\
\'a0 \'a0 \'a0*/\cf0 \
\cf3 \'a0 \'a0 \cf5 def\cf3  \cf6 String\cf3  toToolTip\cf2 (\cf6 Key\cf3  key\cf2 )\cf3  \cf2 \{\cf0 \
\cf3 \'a0 \'a0 \'a0 \'a0 toKeyString\cf2 (\cf3 key\cf2 )\cf0 \
\cf3 \'a0 \'a0 \cf2 \}\cf0 \
\
\cf3 \'a0 \'a0 \cf4 /**\
\'a0 \'a0 \'a0* Short name of this renderer. To be used in the user interface.\
\'a0 \'a0 \'a0*\
\'a0 \'a0 \'a0* @return name\
\'a0 \'a0 \'a0*/\cf0 \
\cf3 \'a0 \'a0 \cf5 def\cf3  \cf6 String\cf3  getName\cf2 ()\cf3  \cf2 \{\cf0 \
\cf3 \'a0 \'a0 \'a0 \'a0 \cf8 "Custom.groovy"\cf0 \
\cf3 \'a0 \'a0 \cf2 \}\cf0 \
\
\cf2 \}}